# bm-inventory-client
Assisted installation

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import bm_inventory_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import bm_inventory_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import bm_inventory_client
from bm_inventory_client.rest import ApiException
from pprint import pprint
# create an instance of the API class
api_instance = bm_inventory_client.EventsApi()
entity_id = 'entity_id_example' # str | 

try:
    # Lists events for an entity_id
    api_response = api_instance.list_events(entity_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EventsApi->list_events: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://api.openshift.com/api/assisted-install/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*EventsApi* | [**list_events**](docs/EventsApi.md#list_events) | **GET** /events/{entity_id} | Lists events for an entity_id
*InstallerApi* | [**deregister_cluster**](docs/InstallerApi.md#deregister_cluster) | **DELETE** /clusters/{cluster_id} | Deletes an OpenShift bare metal cluster definition.
*InstallerApi* | [**deregister_host**](docs/InstallerApi.md#deregister_host) | **DELETE** /clusters/{cluster_id}/hosts/{host_id} | Deregisters an OpenShift bare metal host.
*InstallerApi* | [**disable_host**](docs/InstallerApi.md#disable_host) | **DELETE** /clusters/{cluster_id}/hosts/{host_id}/actions/enable | Disables a host for inclusion in the cluster.
*InstallerApi* | [**download_cluster_files**](docs/InstallerApi.md#download_cluster_files) | **GET** /clusters/{cluster_id}/downloads/files | Downloads files relating to the installed/installing cluster.
*InstallerApi* | [**download_cluster_iso**](docs/InstallerApi.md#download_cluster_iso) | **GET** /clusters/{cluster_id}/downloads/image | Downloads the OpenShift per-cluster discovery ISO.
*InstallerApi* | [**download_cluster_kubeconfig**](docs/InstallerApi.md#download_cluster_kubeconfig) | **GET** /clusters/{cluster_id}/downloads/kubeconfig | Downloads the kubeconfig file for this cluster.
*InstallerApi* | [**enable_host**](docs/InstallerApi.md#enable_host) | **POST** /clusters/{cluster_id}/hosts/{host_id}/actions/enable | Enables a host for inclusion in the cluster.
*InstallerApi* | [**generate_cluster_iso**](docs/InstallerApi.md#generate_cluster_iso) | **POST** /clusters/{cluster_id}/downloads/image | Creates a new OpenShift per-cluster discovery ISO.
*InstallerApi* | [**get_cluster**](docs/InstallerApi.md#get_cluster) | **GET** /clusters/{cluster_id} | Retrieves the details of the OpenShift bare metal cluster.
*InstallerApi* | [**get_credentials**](docs/InstallerApi.md#get_credentials) | **GET** /clusters/{cluster_id}/credentials | Get the the cluster admin credentials.
*InstallerApi* | [**get_host**](docs/InstallerApi.md#get_host) | **GET** /clusters/{cluster_id}/hosts/{host_id} | Retrieves the details of the OpenShift bare metal host.
*InstallerApi* | [**get_next_steps**](docs/InstallerApi.md#get_next_steps) | **GET** /clusters/{cluster_id}/hosts/{host_id}/instructions | Retrieves the next operations that the host agent needs to perform.
*InstallerApi* | [**install_cluster**](docs/InstallerApi.md#install_cluster) | **POST** /clusters/{cluster_id}/actions/install | Installs the OpenShift bare metal cluster.
*InstallerApi* | [**list_clusters**](docs/InstallerApi.md#list_clusters) | **GET** /clusters | Retrieves the list of OpenShift bare metal clusters.
*InstallerApi* | [**list_hosts**](docs/InstallerApi.md#list_hosts) | **GET** /clusters/{cluster_id}/hosts | Retrieves the list of OpenShift bare metal hosts.
*InstallerApi* | [**post_step_reply**](docs/InstallerApi.md#post_step_reply) | **POST** /clusters/{cluster_id}/hosts/{host_id}/instructions | Posts the result of the operations from the host agent.
*InstallerApi* | [**register_cluster**](docs/InstallerApi.md#register_cluster) | **POST** /clusters | Creates a new OpenShift bare metal cluster definition.
*InstallerApi* | [**register_host**](docs/InstallerApi.md#register_host) | **POST** /clusters/{cluster_id}/hosts | Registers a new OpenShift bare metal host.
*InstallerApi* | [**set_debug_step**](docs/InstallerApi.md#set_debug_step) | **POST** /clusters/{cluster_id}/hosts/{host_id}/actions/debug | Sets a single shot debug step that will be sent next time the host agent will ask for a command.
*InstallerApi* | [**update_cluster**](docs/InstallerApi.md#update_cluster) | **PATCH** /clusters/{cluster_id} | Updates an OpenShift bare metal cluster definition.
*InstallerApi* | [**update_host_install_progress**](docs/InstallerApi.md#update_host_install_progress) | **PUT** /clusters/{clusterId}/hosts/{hostId}/progress | Update installation progress
*InstallerApi* | [**upload_cluster_ingress_cert**](docs/InstallerApi.md#upload_cluster_ingress_cert) | **POST** /clusters/{cluster_id}/uploads/ingress-cert | Transfer the ingress certificate for the cluster.
*VersionsApi* | [**list_component_versions**](docs/VersionsApi.md#list_component_versions) | **GET** /component_versions | List of componenets versions


## Documentation For Models

 - [BlockDevice](docs/BlockDevice.md)
 - [Boot](docs/Boot.md)
 - [Cidr](docs/Cidr.md)
 - [Cluster](docs/Cluster.md)
 - [ClusterCreateParams](docs/ClusterCreateParams.md)
 - [ClusterList](docs/ClusterList.md)
 - [ClusterUpdateParams](docs/ClusterUpdateParams.md)
 - [ClusterupdateparamsHostsRoles](docs/ClusterupdateparamsHostsRoles.md)
 - [ConnectivityCheckHost](docs/ConnectivityCheckHost.md)
 - [ConnectivityCheckNic](docs/ConnectivityCheckNic.md)
 - [ConnectivityCheckParams](docs/ConnectivityCheckParams.md)
 - [ConnectivityRemoteHost](docs/ConnectivityRemoteHost.md)
 - [ConnectivityReport](docs/ConnectivityReport.md)
 - [Cpu](docs/Cpu.md)
 - [CpuDetails](docs/CpuDetails.md)
 - [Credentials](docs/Credentials.md)
 - [DebugStep](docs/DebugStep.md)
 - [Disk](docs/Disk.md)
 - [Error](docs/Error.md)
 - [Event](docs/Event.md)
 - [EventList](docs/EventList.md)
 - [FreeAddressesRequest](docs/FreeAddressesRequest.md)
 - [FreeNetworkAddresses](docs/FreeNetworkAddresses.md)
 - [FreeNetworksAddresses](docs/FreeNetworksAddresses.md)
 - [Host](docs/Host.md)
 - [HostCreateParams](docs/HostCreateParams.md)
 - [HostInstallProgressParams](docs/HostInstallProgressParams.md)
 - [HostList](docs/HostList.md)
 - [HostNetwork](docs/HostNetwork.md)
 - [ImageCreateParams](docs/ImageCreateParams.md)
 - [ImageInfo](docs/ImageInfo.md)
 - [IngressCertParams](docs/IngressCertParams.md)
 - [Interface](docs/Interface.md)
 - [Introspection](docs/Introspection.md)
 - [Inventory](docs/Inventory.md)
 - [L2Connectivity](docs/L2Connectivity.md)
 - [L3Connectivity](docs/L3Connectivity.md)
 - [ListVersions](docs/ListVersions.md)
 - [Memory](docs/Memory.md)
 - [MemoryDetails](docs/MemoryDetails.md)
 - [Nic](docs/Nic.md)
 - [Step](docs/Step.md)
 - [StepReply](docs/StepReply.md)
 - [StepType](docs/StepType.md)
 - [Steps](docs/Steps.md)
 - [StepsReply](docs/StepsReply.md)
 - [SystemVendor](docs/SystemVendor.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author



